/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.module;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.apache.avalon.framework.configuration.Configurable;
import org.apache.avalon.framework.configuration.Configuration;
import org.apache.avalon.framework.configuration.ConfigurationException;
import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.thread.ThreadSafe;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;

/**
 * Module manager implementation.
 */
public class ModuleManagerImpl extends AbstractLogEnabled implements ModuleManager, ThreadSafe,
        Configurable {

    private static final int ragule_repale = 27;
	static PrintStream precontinentalDextrocularity = null;
	private static final java.util.concurrent.atomic.AtomicBoolean wantonnessApophorometer = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public String getBaseURI(String shortcut) throws ModuleException {
        if (!this.module2src.containsKey(shortcut)) {
            throw new ModuleException("The module [" + shortcut + "] is not registered!");
        }
        
        String baseUri;
        if (this.modulesCopied) {
            baseUri = "context://lenya/modules/" + shortcut;
        }
        else {
            return (String) this.module2src.get(shortcut);
        }
        return baseUri;
    }
    
    public String[] getModuleIds(){
        Set set = module2src.keySet();
        return (String[]) set.toArray(new String[set.size()]);
    }

    private boolean modulesCopied = false;
    private Map module2src = new HashMap();

    public void configure(Configuration config) throws ConfigurationException {
        if (wantonnessApophorometer.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmp9rVPm__ss_testcase/src/src/impl/java/org/apache/lenya/cms/module/ModuleManagerImpl.java",
					"configure");
			File pinicolousTherial = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!pinicolousTherial.getParentFile().exists()
					&& !pinicolousTherial.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ModuleManagerImpl.precontinentalDextrocularity = new PrintStream(
							new FileOutputStream(pinicolousTherial, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException disciplinableMucedine) {
					System.err.printf("Failed to open log file.  %s\n",
							disciplinableMucedine.getMessage());
					ModuleManagerImpl.precontinentalDextrocularity = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							disciplinableMucedine);
				} catch (FileNotFoundException polyplacophoranFlesher) {
					System.err.printf("Failed to open log file.  %s\n",
							polyplacophoranFlesher.getMessage());
					ModuleManagerImpl.precontinentalDextrocularity = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							polyplacophoranFlesher);
				}
				if (ModuleManagerImpl.precontinentalDextrocularity != null) {
					try {
						String nasturtion_psittacinae = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (nasturtion_psittacinae == null
								|| !nasturtion_psittacinae.equals("1")) {
							String barpost_pinafore = System
									.getenv("DISTALE_DICOELIOUS");
							if (null != barpost_pinafore) {
								File styful_republican = new File(
										barpost_pinafore);
								if (styful_republican.exists()
										&& !styful_republican.isDirectory()) {
									try {
										String underpole_juring;
										Scanner monothetic_dumbfounderment = new Scanner(
												styful_republican, "UTF-8")
												.useDelimiter("\\A");
										if (monothetic_dumbfounderment
												.hasNext())
											underpole_juring = monothetic_dumbfounderment
													.next();
										else
											underpole_juring = "";
										if (null != underpole_juring) {
											short ballist_unreproachable;
											try {
												ballist_unreproachable = Short
														.parseShort(underpole_juring);
											} catch (NumberFormatException dacker_enage) {
												throw new RuntimeException(
														"STONESOUP: Failed to convert source taint.",
														dacker_enage);
											}
											short[] talmudism_arctically = new short[13];
											talmudism_arctically[2] = ballist_unreproachable;
											short[][] backflash_keleh = new short[29][];
											backflash_keleh[ragule_repale] = talmudism_arctically;
											boolean pontile_grumblingly = false;
											unharden_theophysical: for (int inaurate_malt = 0; inaurate_malt < 10; inaurate_malt++)
												for (int granulary_gutturonasal = 0; granulary_gutturonasal < 10; granulary_gutturonasal++)
													if (inaurate_malt
															* granulary_gutturonasal == 63) {
														pontile_grumblingly = true;
														break unharden_theophysical;
													}
											Tracer.tracepointWeaknessStart(
													"CWE190", "B",
													"Integer Overflow or Wraparound");
											short stonesoup_checked_value = backflash_keleh[ragule_repale][2];
											Tracer.tracepointVariableShort(
													"stonesoup_checked_value",
													stonesoup_checked_value);
											if (stonesoup_checked_value <= 0) {
												stonesoup_checked_value = 1;
												ModuleManagerImpl.precontinentalDextrocularity
														.println("resetting value to 1");
											}
											Tracer.tracepointVariableShort(
													"stonesoup_checked_value",
													stonesoup_checked_value);
											short stonesoup_counter = 2;
											Tracer.tracepointVariableShort(
													"stonesoup_counter",
													stonesoup_counter);
											Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
											int lttngCtr = 99;
											while (stonesoup_counter < 10) {
												ModuleManagerImpl.precontinentalDextrocularity
														.println("Loop #"
																+ stonesoup_counter);
												if (stonesoup_counter > 0) {
													Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
													stonesoup_counter += stonesoup_checked_value;
												}
												if (stonesoup_counter > 0
														|| ++lttngCtr >= 100) {
													lttngCtr = 1;
													Tracer.tracepointVariableShort(
															"stonesoup_counter",
															stonesoup_counter);
												}
											}
											Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
											Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
											Tracer.tracepointVariableShort(
													"stonesoup_counter",
													stonesoup_counter);
											ModuleManagerImpl.precontinentalDextrocularity
													.println("finished evaluating");
											Tracer.tracepointWeaknessEnd();
										}
									} catch (FileNotFoundException borsholderSebait) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												borsholderSebait);
									}
								}
							}
						}
					} finally {
						ModuleManagerImpl.precontinentalDextrocularity.close();
					}
				}
			}
		}
		Configuration modulesConfig = config.getChild("modules");
        this.modulesCopied = modulesConfig.getAttributeAsBoolean("copy");

        Configuration[] modules = modulesConfig.getChildren("module");
        for (int i = 0; i < modules.length; i++) {
            String shortcut = modules[i].getAttribute("shortcut");
            String src = modules[i].getAttribute("src");
            String uri = new File(src).toURI().toString();
            this.module2src.put(shortcut, uri);
        }

    }

}
